(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-spinners', ['exports', '@angular/core', '@angular/common'], factory) :
    (global = global || self, factory(global['ngx-spinners'] = {}, global.ng.core, global.ng.common));
}(this, function (exports, core, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SyncLoaderComponent = /** @class */ (function () {
        function SyncLoaderComponent() {
            this.color = 'rgb(54, 215, 183)';
            this.size = 15;
            this.sizeUnit = 'px';
            this.margin = 2;
            this.marginUnit = 'px';
        }
        /**
         * @param {?} index
         * @return {?}
         */
        SyncLoaderComponent.prototype.createBallStyle = /**
         * @param {?} index
         * @return {?}
         */
        function (index) {
            return {
                'display': 'inline-block',
                'background-color': "" + this.color,
                'width': "" + ("" + this.size + this.sizeUnit),
                'height': "" + ("" + this.size + this.sizeUnit),
                'margin': "" + ("" + this.margin + this.marginUnit),
                'border-radius': '100%',
                'animation': "loading 0.6s " + index * 0.07 + "s infinite ease-in-out",
                'animation-fill-mode': 'both'
            };
        };
        SyncLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-sync-loader',
                        template: "<div class=\"loader\">\n  <div [ngStyle]=\"createBallStyle(1)\"></div>\n  <div [ngStyle]=\"createBallStyle(2)\"></div>\n  <div [ngStyle]=\"createBallStyle(3)\"></div>\n</div>\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: ["@-webkit-keyframes loading{33%{-webkit-transform:translateY(10px);transform:translateY(10px)}66%{-webkit-transform:translateY(-10px);transform:translateY(-10px)}100%{-webkit-transform:translateY(0);transform:translateY(0)}}@keyframes loading{33%{-webkit-transform:translateY(10px);transform:translateY(10px)}66%{-webkit-transform:translateY(-10px);transform:translateY(-10px)}100%{-webkit-transform:translateY(0);transform:translateY(0)}}"]
                    }] }
        ];
        /** @nocollapse */
        SyncLoaderComponent.ctorParameters = function () { return []; };
        SyncLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            sizeUnit: [{ type: core.Input }],
            margin: [{ type: core.Input }],
            marginUnit: [{ type: core.Input }]
        };
        return SyncLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SquareLoaderComponent = /** @class */ (function () {
        function SquareLoaderComponent() {
            this.color = 'rgb(54, 215, 183)';
            this.size = 15;
            this.sizeUnit = 'px';
            this.margin = 2;
            this.marginUnit = 'px';
        }
        /**
         * @return {?}
         */
        SquareLoaderComponent.prototype.createBoxStyle = /**
         * @return {?}
         */
        function () {
            return {
                'display': 'inline-block',
                'background-color': "" + this.color,
                'width': "" + ("" + this.size + this.sizeUnit),
                'height': "" + ("" + this.size + this.sizeUnit),
                'animation': 'loading 3s 0s infinite cubic-bezier(.09,.57,.49,.9)',
                'animation-fill-mode': 'both'
            };
        };
        SquareLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-square-loader',
                        template: "<div class=\"loader\" [ngStyle]=\"createBoxStyle()\"></div>\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: ["@-webkit-keyframes loading{25%{-webkit-transform:rotateX(180deg) rotateY(0);transform:rotateX(180deg) rotateY(0)}50%{-webkit-transform:rotateX(180deg) rotateY(180deg);transform:rotateX(180deg) rotateY(180deg)}75%{-webkit-transform:rotateX(0) rotateY(180deg);transform:rotateX(0) rotateY(180deg)}100%{-webkit-transform:rotateX(0) rotateY(0);transform:rotateX(0) rotateY(0)}}@keyframes loading{25%{-webkit-transform:rotateX(180deg) rotateY(0);transform:rotateX(180deg) rotateY(0)}50%{-webkit-transform:rotateX(180deg) rotateY(180deg);transform:rotateX(180deg) rotateY(180deg)}75%{-webkit-transform:rotateX(0) rotateY(180deg);transform:rotateX(0) rotateY(180deg)}100%{-webkit-transform:rotateX(0) rotateY(0);transform:rotateX(0) rotateY(0)}}"]
                    }] }
        ];
        /** @nocollapse */
        SquareLoaderComponent.ctorParameters = function () { return []; };
        SquareLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            sizeUnit: [{ type: core.Input }],
            margin: [{ type: core.Input }],
            marginUnit: [{ type: core.Input }]
        };
        return SquareLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SkewLoaderComponent = /** @class */ (function () {
        function SkewLoaderComponent() {
            this.color = 'rgb(54, 215, 183)';
            this.size = 15;
            this.sizeUnit = 'px';
        }
        /**
         * @return {?}
         */
        SkewLoaderComponent.prototype.createSkewStyle = /**
         * @return {?}
         */
        function () {
            return {
                'display': 'inline-block',
                'width': '0',
                'height': '0',
                'border-left': "" + this.size + this.sizeUnit + " solid transparent",
                'border-right': "" + this.size + this.sizeUnit + " solid transparent",
                'border-bottom': "" + this.size + this.sizeUnit + " solid " + this.color,
                'animation': 'loading 3s 0s infinite cubic-bezier(.09,.57,.49,.9)',
                'animation-fill-mode': 'both'
            };
        };
        SkewLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-skew-loader',
                        template: "<div class=\"loader\" [ngStyle]=\"createSkewStyle()\"></div>\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: ["@-webkit-keyframes loading{25%{-webkit-transform:perspective(100px) rotateX(180deg) rotateY(0);transform:perspective(100px) rotateX(180deg) rotateY(0)}50%{-webkit-transform:perspective(100px) rotateX(180deg) rotateY(180deg);transform:perspective(100px) rotateX(180deg) rotateY(180deg)}75%{-webkit-transform:perspective(100px) rotateX(0) rotateY(180deg);transform:perspective(100px) rotateX(0) rotateY(180deg)}100%{-webkit-transform:perspective(100px) rotateX(0) rotateY(0);transform:perspective(100px) rotateX(0) rotateY(0)}}@keyframes loading{25%{-webkit-transform:perspective(100px) rotateX(180deg) rotateY(0);transform:perspective(100px) rotateX(180deg) rotateY(0)}50%{-webkit-transform:perspective(100px) rotateX(180deg) rotateY(180deg);transform:perspective(100px) rotateX(180deg) rotateY(180deg)}75%{-webkit-transform:perspective(100px) rotateX(0) rotateY(180deg);transform:perspective(100px) rotateX(0) rotateY(180deg)}100%{-webkit-transform:perspective(100px) rotateX(0) rotateY(0);transform:perspective(100px) rotateX(0) rotateY(0)}}"]
                    }] }
        ];
        /** @nocollapse */
        SkewLoaderComponent.ctorParameters = function () { return []; };
        SkewLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            sizeUnit: [{ type: core.Input }]
        };
        return SkewLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ScaleLoaderComponent = /** @class */ (function () {
        function ScaleLoaderComponent() {
            this.color = 'rgb(54, 215, 183)';
            this.width = 4;
            this.widthUnit = 'px';
            this.height = 35;
            this.heightUnit = 'px';
            this.margin = 2;
            this.marginUnit = 'px';
            this.radius = 2;
            this.radiusUnit = 'px';
        }
        /**
         * @param {?} index
         * @return {?}
         */
        ScaleLoaderComponent.prototype.createScaleStyle = /**
         * @param {?} index
         * @return {?}
         */
        function (index) {
            return {
                'display': 'inline-block',
                'background-color': "" + this.color,
                'width': "" + ("" + this.width + this.widthUnit),
                'height': "" + ("" + this.height + this.heightUnit),
                'margin': "" + ("" + this.margin + this.marginUnit),
                'border-radius': "" + ("" + this.radius + this.radiusUnit),
                'animation': "loading 1s " + index * 0.1 + "s infinite cubic-bezier(.2,.68,.18,1.08)",
                'animation-fill-mode': 'both'
            };
        };
        ScaleLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-scale-loader',
                        template: "<div class=\"loader\">\n  <div [ngStyle]=\"createScaleStyle(1)\"></div>\n  <div [ngStyle]=\"createScaleStyle(2)\"></div>\n  <div [ngStyle]=\"createScaleStyle(3)\"></div>\n  <div [ngStyle]=\"createScaleStyle(4)\"></div>\n  <div [ngStyle]=\"createScaleStyle(5)\"></div>\n</div>\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: ["@-webkit-keyframes loading{0%,100%{-webkit-transform:scaleY(1);transform:scaleY(1)}50%{-webkit-transform:scaleY(.4);transform:scaleY(.4)}}@keyframes loading{0%,100%{-webkit-transform:scaleY(1);transform:scaleY(1)}50%{-webkit-transform:scaleY(.4);transform:scaleY(.4)}}"]
                    }] }
        ];
        /** @nocollapse */
        ScaleLoaderComponent.ctorParameters = function () { return []; };
        ScaleLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            width: [{ type: core.Input }],
            widthUnit: [{ type: core.Input }],
            height: [{ type: core.Input }],
            heightUnit: [{ type: core.Input }],
            margin: [{ type: core.Input }],
            marginUnit: [{ type: core.Input }],
            radius: [{ type: core.Input }],
            radiusUnit: [{ type: core.Input }]
        };
        return ScaleLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var RotateLoaderComponent = /** @class */ (function () {
        function RotateLoaderComponent() {
            this.color = 'rgb(54, 215, 183)';
            this.size = 15;
            this.sizeUnit = 'px';
            this.margin = 2;
            this.marginUnit = 'px';
        }
        /**
         * @return {?}
         */
        RotateLoaderComponent.prototype.createRotateWrapperStyle = /**
         * @return {?}
         */
        function () {
            return __assign({ 'display': 'inline-block' }, this.createBallStyle(), { 'position': 'relative', 'animation-fill-mode': 'both', 'animation': 'loading 1s 0s infinite cubic-bezier(.7,-.13,.22,.86)' });
        };
        /**
         * @return {?}
         */
        RotateLoaderComponent.prototype.createRotateLongStyle = /**
         * @return {?}
         */
        function () {
            return __assign({}, this.createBallStyle(), this.createPositionStyle(1));
        };
        /**
         * @return {?}
         */
        RotateLoaderComponent.prototype.createRotateShortStyle = /**
         * @return {?}
         */
        function () {
            return __assign({}, this.createBallStyle(), this.createPositionStyle(2));
        };
        /**
         * @private
         * @return {?}
         */
        RotateLoaderComponent.prototype.createBallStyle = /**
         * @private
         * @return {?}
         */
        function () {
            return {
                'background-color': "" + this.color,
                'width': "" + ("" + this.size + this.sizeUnit),
                'height': "" + ("" + this.size + this.sizeUnit),
                'margin': "" + ("" + this.margin + this.marginUnit),
                'border-radius': '100%'
            };
        };
        /**
         * @private
         * @param {?} index
         * @return {?}
         */
        RotateLoaderComponent.prototype.createPositionStyle = /**
         * @private
         * @param {?} index
         * @return {?}
         */
        function (index) {
            return {
                'opacity': '0.8',
                'position': 'absolute',
                'top': '0',
                'left': (index % 2 ? -28 : 25) + "px"
            };
        };
        RotateLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-rotate-loader',
                        template: "<div class=\"loader\" [ngStyle]=\"createRotateWrapperStyle()\">\n  <div [ngStyle]=\"createRotateLongStyle()\"></div>\n  <div [ngStyle]=\"createRotateShortStyle()\"></div>\n</div>\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: ["@-webkit-keyframes loading{0%{-webkit-transform:rotate(0);transform:rotate(0)}50%{-webkit-transform:rotate(180deg);transform:rotate(180deg)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes loading{0%{-webkit-transform:rotate(0);transform:rotate(0)}50%{-webkit-transform:rotate(180deg);transform:rotate(180deg)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}"]
                    }] }
        ];
        /** @nocollapse */
        RotateLoaderComponent.ctorParameters = function () { return []; };
        RotateLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            sizeUnit: [{ type: core.Input }],
            margin: [{ type: core.Input }],
            marginUnit: [{ type: core.Input }]
        };
        return RotateLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var RiseLoaderComponent = /** @class */ (function () {
        function RiseLoaderComponent() {
            this.color = 'rgb(54, 215, 183)';
            this.size = 15;
            this.sizeUnit = 'px';
            this.margin = 2;
            this.marginUnit = 'px';
        }
        /**
         * @param {?} index
         * @return {?}
         */
        RiseLoaderComponent.prototype.createRiseStyle = /**
         * @param {?} index
         * @return {?}
         */
        function (index) {
            return {
                'display': 'inline-block',
                'border-radius': '100%',
                'background-color': "" + this.color,
                'width': "" + ("" + this.size + this.sizeUnit),
                'height': "" + ("" + this.size + this.sizeUnit),
                'margin': "" + ("" + this.margin + this.marginUnit),
                'animation': (index % 2 === 0 ? 'loading-even' : 'loading-odd') + " 1s 0s infinite cubic-bezier(.15,.46,.9,.6)",
                'animation-fill-mode': 'both'
            };
        };
        RiseLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-rise-loader',
                        template: "<div class=\"loader\">\n  <div [ngStyle]=\"createRiseStyle(1)\"></div>\n  <div [ngStyle]=\"createRiseStyle(2)\"></div>\n  <div [ngStyle]=\"createRiseStyle(3)\"></div>\n  <div [ngStyle]=\"createRiseStyle(4)\"></div>\n  <div [ngStyle]=\"createRiseStyle(5)\"></div>\n</div>\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: [":host{--riseAmount:30px}@-webkit-keyframes loading-even{0%{-webkit-transform:scale(1.1);transform:scale(1.1)}50%{-webkit-transform:scale(.4);transform:scale(.4)}75%{-webkit-transform:translateY(var(--riseAmount));transform:translateY(var(--riseAmount))}100%{-webkit-transform:translateY(0) scale(1);transform:translateY(0) scale(1)}}@keyframes loading-even{0%{-webkit-transform:scale(1.1);transform:scale(1.1)}50%{-webkit-transform:scale(.4);transform:scale(.4)}75%{-webkit-transform:translateY(var(--riseAmount));transform:translateY(var(--riseAmount))}100%{-webkit-transform:translateY(0) scale(1);transform:translateY(0) scale(1)}}@-webkit-keyframes loading-odd{0%{-webkit-transform:scale(.4);transform:scale(.4)}50%{-webkit-transform:scale(1.1);transform:scale(1.1)}75%{-webkit-transform:translateY(calc(-1 * var(--riseAmount)));transform:translateY(calc(-1 * var(--riseAmount)))}100%{-webkit-transform:translateY(0) scale(.75);transform:translateY(0) scale(.75)}}@keyframes loading-odd{0%{-webkit-transform:scale(.4);transform:scale(.4)}50%{-webkit-transform:scale(1.1);transform:scale(1.1)}75%{-webkit-transform:translateY(calc(-1 * var(--riseAmount)));transform:translateY(calc(-1 * var(--riseAmount)))}100%{-webkit-transform:translateY(0) scale(.75);transform:translateY(0) scale(.75)}}"]
                    }] }
        ];
        /** @nocollapse */
        RiseLoaderComponent.ctorParameters = function () { return []; };
        RiseLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            sizeUnit: [{ type: core.Input }],
            margin: [{ type: core.Input }],
            marginUnit: [{ type: core.Input }]
        };
        return RiseLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var RingLoaderComponent = /** @class */ (function () {
        function RingLoaderComponent() {
            this.color = 'rgb(54, 215, 183)';
            this.size = 60;
            this.sizeUnit = 'px';
        }
        /**
         * @return {?}
         */
        RingLoaderComponent.prototype.createRingWrapperStyle = /**
         * @return {?}
         */
        function () {
            return {
                'width': "" + ("" + this.size + this.sizeUnit),
                'height': "" + ("" + this.size + this.sizeUnit),
                'position': 'relative'
            };
        };
        /**
         * @param {?} index
         * @return {?}
         */
        RingLoaderComponent.prototype.createRingStyle = /**
         * @param {?} index
         * @return {?}
         */
        function (index) {
            return {
                'position': 'absolute',
                'top': '0',
                'left': '0',
                'width': "" + ("" + this.size + this.sizeUnit),
                'height': "" + ("" + this.size + this.sizeUnit),
                'border': "" + this.size / 10 + this.sizeUnit + " solid " + this.color,
                'opacity': '0.4',
                'border-radius': '100%',
                'animation-fill-mode': 'forwards',
                'perspective': '800px',
                'animation': (index === 1 ? 'loading-right' : 'loading-left') + " 2s 0s infinite linear"
            };
        };
        RingLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-ring-loader',
                        template: "<div class=\"loader\" [ngStyle]=\"createRingWrapperStyle()\">\n  <div [ngStyle]=\"createRingStyle(1)\"></div>\n  <div [ngStyle]=\"createRingStyle(2)\"></div>\n</div>\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: ["@-webkit-keyframes loading-right{0%{-webkit-transform:rotateX(0) rotateY(0) rotateZ(0);transform:rotateX(0) rotateY(0) rotateZ(0)}100%{-webkit-transform:rotateX(180deg) rotateY(360deg) rotateZ(360deg);transform:rotateX(180deg) rotateY(360deg) rotateZ(360deg)}}@keyframes loading-right{0%{-webkit-transform:rotateX(0) rotateY(0) rotateZ(0);transform:rotateX(0) rotateY(0) rotateZ(0)}100%{-webkit-transform:rotateX(180deg) rotateY(360deg) rotateZ(360deg);transform:rotateX(180deg) rotateY(360deg) rotateZ(360deg)}}@-webkit-keyframes loading-left{0%{-webkit-transform:rotateX(0) rotateY(0) rotateZ(0);transform:rotateX(0) rotateY(0) rotateZ(0)}100%{-webkit-transform:rotateX(360deg) rotateY(180deg) rotateZ(360deg);transform:rotateX(360deg) rotateY(180deg) rotateZ(360deg)}}@keyframes loading-left{0%{-webkit-transform:rotateX(0) rotateY(0) rotateZ(0);transform:rotateX(0) rotateY(0) rotateZ(0)}100%{-webkit-transform:rotateX(360deg) rotateY(180deg) rotateZ(360deg);transform:rotateX(360deg) rotateY(180deg) rotateZ(360deg)}}"]
                    }] }
        ];
        /** @nocollapse */
        RingLoaderComponent.ctorParameters = function () { return []; };
        RingLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            sizeUnit: [{ type: core.Input }]
        };
        return RingLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PulseLoaderComponent = /** @class */ (function () {
        function PulseLoaderComponent() {
            this.color = 'rgb(54, 215, 183)';
            this.size = 15;
            this.sizeUnit = 'px';
            this.margin = 2;
            this.marginUnit = 'px';
        }
        /**
         * @param {?} index
         * @return {?}
         */
        PulseLoaderComponent.prototype.createPulseStyle = /**
         * @param {?} index
         * @return {?}
         */
        function (index) {
            return {
                'display': 'inline-block',
                'background-color': "" + this.color,
                'width': "" + ("" + this.size + this.sizeUnit),
                'height': "" + ("" + this.size + this.sizeUnit),
                'margin': "" + ("" + this.margin + this.marginUnit),
                'border-radius': '100%',
                'animation': "loading 0.75s " + index * 0.12 + "s infinite cubic-bezier(.2,.68,.18,1.08)",
                'animation-fill-mode': 'both'
            };
        };
        PulseLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-pulse-loader',
                        template: "<div class=\"loader\">\n  <div [ngStyle]=\"createPulseStyle(1)\"></div>\n  <div [ngStyle]=\"createPulseStyle(2)\"></div>\n  <div [ngStyle]=\"createPulseStyle(3)\"></div>\n</div>\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: ["@-webkit-keyframes loading{0%,80%{-webkit-transform:scale(1);transform:scale(1);opacity:1}45%{-webkit-transform:scale(.1);transform:scale(.1);opacity:.7}}@keyframes loading{0%,80%{-webkit-transform:scale(1);transform:scale(1);opacity:1}45%{-webkit-transform:scale(.1);transform:scale(.1);opacity:.7}}"]
                    }] }
        ];
        /** @nocollapse */
        PulseLoaderComponent.ctorParameters = function () { return []; };
        PulseLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            sizeUnit: [{ type: core.Input }],
            margin: [{ type: core.Input }],
            marginUnit: [{ type: core.Input }]
        };
        return PulseLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PropagateLoaderComponent = /** @class */ (function () {
        function PropagateLoaderComponent() {
            this.color = 'rgb(54, 215, 183)';
            this.size = 15;
            this.sizeUnit = 'px';
        }
        /**
         * @return {?}
         */
        PropagateLoaderComponent.prototype.createPropagateWrapperStyle = /**
         * @return {?}
         */
        function () {
            return {
                'position': 'relative'
            };
        };
        /**
         * @param {?} index
         * @return {?}
         */
        PropagateLoaderComponent.prototype.createPropagateStyle = /**
         * @param {?} index
         * @return {?}
         */
        function (index) {
            return {
                'position': 'absolute',
                'font-size': "" + ("" + this.size / 3 + this.sizeUnit),
                'width': "" + ("" + this.size + this.sizeUnit),
                'height': "" + ("" + this.size + this.sizeUnit),
                'background': "" + this.color,
                'border-radius': '50%',
                'animation': 'loading-' + index + " 1.5s  infinite",
                'animation-fill-mode': 'forwards'
            };
        };
        PropagateLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-propagate-loader',
                        template: "<div class=\"loader\" [ngStyle]=\"createPropagateWrapperStyle()\">\n  <div [ngStyle]=\"createPropagateStyle(0)\"></div>\n  <div [ngStyle]=\"createPropagateStyle(1)\"></div>\n  <div [ngStyle]=\"createPropagateStyle(2)\"></div>\n  <div [ngStyle]=\"createPropagateStyle(3)\"></div>\n  <div [ngStyle]=\"createPropagateStyle(4)\"></div>\n  <div [ngStyle]=\"createPropagateStyle(5)\"></div>\n</div>\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: [":host{--oneRem:1rem;--threeRem:3rem;--fiveRem:5rem}@-webkit-keyframes loading-0{25%{-webkit-transform:translateX(calc(-1 * var(--oneRem))) scale(.75);transform:translateX(calc(-1 * var(--oneRem))) scale(.75)}50%{-webkit-transform:translateX(calc(-1 * var(--threeRem))) scale(.6);transform:translateX(calc(-1 * var(--threeRem))) scale(.6)}75%{-webkit-transform:translateX(calc(-1 * var(--fiveRem))) scale(.5);transform:translateX(calc(-1 * var(--fiveRem))) scale(.5)}95%{-webkit-transform:translateX(0) scale(1);transform:translateX(0) scale(1)}}@keyframes loading-0{25%{-webkit-transform:translateX(calc(-1 * var(--oneRem))) scale(.75);transform:translateX(calc(-1 * var(--oneRem))) scale(.75)}50%{-webkit-transform:translateX(calc(-1 * var(--threeRem))) scale(.6);transform:translateX(calc(-1 * var(--threeRem))) scale(.6)}75%{-webkit-transform:translateX(calc(-1 * var(--fiveRem))) scale(.5);transform:translateX(calc(-1 * var(--fiveRem))) scale(.5)}95%{-webkit-transform:translateX(0) scale(1);transform:translateX(0) scale(1)}}@-webkit-keyframes loading-1{25%{-webkit-transform:translateX(calc(-1 * var(--oneRem))) scale(.75);transform:translateX(calc(-1 * var(--oneRem))) scale(.75)}50%,75%{-webkit-transform:translateX(calc(-1 * var(--threeRem))) scale(.6);transform:translateX(calc(-1 * var(--threeRem))) scale(.6)}95%{-webkit-transform:translateX(0) scale(1);transform:translateX(0) scale(1)}}@keyframes loading-1{25%{-webkit-transform:translateX(calc(-1 * var(--oneRem))) scale(.75);transform:translateX(calc(-1 * var(--oneRem))) scale(.75)}50%,75%{-webkit-transform:translateX(calc(-1 * var(--threeRem))) scale(.6);transform:translateX(calc(-1 * var(--threeRem))) scale(.6)}95%{-webkit-transform:translateX(0) scale(1);transform:translateX(0) scale(1)}}@-webkit-keyframes loading-2{25%,75%{-webkit-transform:translateX(calc(-1 * var(--oneRem))) scale(.75);transform:translateX(calc(-1 * var(--oneRem))) scale(.75)}95%{-webkit-transform:translateX(0) scale(1);transform:translateX(0) scale(1)}}@keyframes loading-2{25%,75%{-webkit-transform:translateX(calc(-1 * var(--oneRem))) scale(.75);transform:translateX(calc(-1 * var(--oneRem))) scale(.75)}95%{-webkit-transform:translateX(0) scale(1);transform:translateX(0) scale(1)}}@-webkit-keyframes loading-3{25%,75%{-webkit-transform:translateX(var(--oneRem)) scale(.75);transform:translateX(var(--oneRem)) scale(.75)}95%{-webkit-transform:translateX(0) scale(1);transform:translateX(0) scale(1)}}@keyframes loading-3{25%,75%{-webkit-transform:translateX(var(--oneRem)) scale(.75);transform:translateX(var(--oneRem)) scale(.75)}95%{-webkit-transform:translateX(0) scale(1);transform:translateX(0) scale(1)}}@-webkit-keyframes loading-4{25%{-webkit-transform:translateX(var(--oneRem)) scale(.75);transform:translateX(var(--oneRem)) scale(.75)}50%,75%{-webkit-transform:translateX(var(--threeRem)) scale(.6);transform:translateX(var(--threeRem)) scale(.6)}95%{-webkit-transform:translateX(0) scale(1);transform:translateX(0) scale(1)}}@keyframes loading-4{25%{-webkit-transform:translateX(var(--oneRem)) scale(.75);transform:translateX(var(--oneRem)) scale(.75)}50%,75%{-webkit-transform:translateX(var(--threeRem)) scale(.6);transform:translateX(var(--threeRem)) scale(.6)}95%{-webkit-transform:translateX(0) scale(1);transform:translateX(0) scale(1)}}@-webkit-keyframes loading-5{25%{-webkit-transform:translateX(var(--oneRem)) scale(.75);transform:translateX(var(--oneRem)) scale(.75)}50%{-webkit-transform:translateX(var(--threeRem)) scale(.6);transform:translateX(var(--threeRem)) scale(.6)}75%{-webkit-transform:translateX(var(--fiveRem)) scale(.5);transform:translateX(var(--fiveRem)) scale(.5)}95%{-webkit-transform:translateX(0) scale(1);transform:translateX(0) scale(1)}}@keyframes loading-5{25%{-webkit-transform:translateX(var(--oneRem)) scale(.75);transform:translateX(var(--oneRem)) scale(.75)}50%{-webkit-transform:translateX(var(--threeRem)) scale(.6);transform:translateX(var(--threeRem)) scale(.6)}75%{-webkit-transform:translateX(var(--fiveRem)) scale(.5);transform:translateX(var(--fiveRem)) scale(.5)}95%{-webkit-transform:translateX(0) scale(1);transform:translateX(0) scale(1)}}"]
                    }] }
        ];
        /** @nocollapse */
        PropagateLoaderComponent.ctorParameters = function () { return []; };
        PropagateLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            sizeUnit: [{ type: core.Input }]
        };
        return PropagateLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PacmanLoaderComponent = /** @class */ (function () {
        function PacmanLoaderComponent(elementRef) {
            this.elementRef = elementRef;
            this.color = 'rgb(54, 215, 183)';
            this.size = 25;
            this.sizeUnit = 'px';
            this.margin = 2;
            this.marginUnit = 'px';
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        PacmanLoaderComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            var size = changes.size, sizeUnit = changes.sizeUnit;
            if (size && !isNaN(size.currentValue) && sizeUnit && typeof sizeUnit.currentValue === 'string') {
                this.elementRef.nativeElement.style.setProperty('--tx', "" + ("" + -4 * size.currentValue + sizeUnit.currentValue));
                this.elementRef.nativeElement.style.setProperty('--ty', "" + ("" + (-1 * size.currentValue) / 4 + sizeUnit.currentValue));
            }
        };
        /**
         * @return {?}
         */
        PacmanLoaderComponent.prototype.createPacmanWrapperStyle = /**
         * @return {?}
         */
        function () {
            return {
                'position': 'relative',
                'font-size': '0',
                'height': "" + ("" + this.size + this.sizeUnit),
                'width': "" + ("" + this.size + this.sizeUnit)
            };
        };
        /**
         * @return {?}
         */
        PacmanLoaderComponent.prototype.createPacStyle = /**
         * @return {?}
         */
        function () {
            return this.createPacManStyle(0);
        };
        /**
         * @return {?}
         */
        PacmanLoaderComponent.prototype.createManStyle = /**
         * @return {?}
         */
        function () {
            return this.createPacManStyle(1);
        };
        /**
         * @param {?} index
         * @return {?}
         */
        PacmanLoaderComponent.prototype.createBallStyle = /**
         * @param {?} index
         * @return {?}
         */
        function (index) {
            return {
                'width': "" + ("" + this.size / 3 + this.sizeUnit),
                'height': "" + ("" + this.size / 3 + this.sizeUnit),
                'background-color': "" + this.color,
                'margin': "" + ("" + this.margin + this.marginUnit),
                'border-radius': '100%',
                'transform': "translate(0, " + ("" + -this.size / 4 + this.sizeUnit) + ")",
                'position': 'absolute',
                'top': this.size + "px",
                'left': "" + ("" + this.size * 4 + this.sizeUnit),
                'animation': "loading-ball 1s " + index * 0.25 + "s infinite linear",
                'animation-fill-mode': 'both'
            };
        };
        /**
         * @private
         * @param {?} index
         * @return {?}
         */
        PacmanLoaderComponent.prototype.createPacManStyle = /**
         * @private
         * @param {?} index
         * @return {?}
         */
        function (index) {
            /** @type {?} */
            var s1 = this.s1();
            /** @type {?} */
            var s2 = this.s2();
            return {
                'width': '0',
                'height': '0',
                'border-right': "" + s1,
                'border-top': "" + (index === 0 ? s1 : s2),
                'border-left': "" + s2,
                'border-bottom': "" + (index === 0 ? s2 : s1),
                'border-radius': "" + ("" + this.size + this.sizeUnit),
                'position': 'absolute',
                'animation': 'loading-pacman-' + index + " 0.8s infinite ease-in-out",
                'animation-fill-mode': 'both'
            };
        };
        /**
         * @private
         * @return {?}
         */
        PacmanLoaderComponent.prototype.s1 = /**
         * @private
         * @return {?}
         */
        function () {
            return "" + this.size + this.sizeUnit + " solid transparent";
        };
        /**
         * @private
         * @return {?}
         */
        PacmanLoaderComponent.prototype.s2 = /**
         * @private
         * @return {?}
         */
        function () {
            return "" + this.size + this.sizeUnit + " solid " + this.color;
        };
        PacmanLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-pacman-loader',
                        template: "<div class=\"loader\" [ngStyle]=\"createPacmanWrapperStyle()\">\n  <div [ngStyle]=\"createPacStyle()\"></div>\n  <div [ngStyle]=\"createManStyle()\"></div>\n  <div [ngStyle]=\"createBallStyle(2)\"></div>\n  <div [ngStyle]=\"createBallStyle(3)\"></div>\n  <div [ngStyle]=\"createBallStyle(4)\"></div>\n  <div [ngStyle]=\"createBallStyle(5)\"></div>\n</div>\n",
                        styles: [":host{--tx:calc(-4 * 25px);--ty:calc((-1 * 25px) / 4)}@-webkit-keyframes loading-ball{75%{opacity:.7}100%{-webkit-transform:translate(var(--tx),var(--ty));transform:translate(var(--tx),var(--ty))}}@keyframes loading-ball{75%{opacity:.7}100%{-webkit-transform:translate(var(--tx),var(--ty));transform:translate(var(--tx),var(--ty))}}@-webkit-keyframes loading-pacman-0{0%{-webkit-transform:rotate(0);transform:rotate(0)}50%{-webkit-transform:rotate(-44deg);transform:rotate(-44deg)}}@keyframes loading-pacman-0{0%{-webkit-transform:rotate(0);transform:rotate(0)}50%{-webkit-transform:rotate(-44deg);transform:rotate(-44deg)}}@-webkit-keyframes loading-pacman-1{0%{-webkit-transform:rotate(0);transform:rotate(0)}50%{-webkit-transform:rotate(44deg);transform:rotate(44deg)}}@keyframes loading-pacman-1{0%{-webkit-transform:rotate(0);transform:rotate(0)}50%{-webkit-transform:rotate(44deg);transform:rotate(44deg)}}"]
                    }] }
        ];
        /** @nocollapse */
        PacmanLoaderComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        PacmanLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            sizeUnit: [{ type: core.Input }],
            margin: [{ type: core.Input }],
            marginUnit: [{ type: core.Input }]
        };
        return PacmanLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MoonLoaderComponent = /** @class */ (function () {
        function MoonLoaderComponent() {
            this.color = 'rgb(54, 215, 183)';
            this.size = 60;
            this.sizeUnit = 'px';
        }
        /**
         * @return {?}
         */
        MoonLoaderComponent.prototype.createMoonWrapperStyle = /**
         * @return {?}
         */
        function () {
            return {
                'position': 'relative',
                'width': "" + ("" + (this.size + ((this.size / 7) * 2)) + this.sizeUnit),
                'height': "" + ("" + (this.size + ((this.size / 7) * 2)) + this.sizeUnit),
                'animation': 'loading 0.6s 0s infinite linear',
                'animation-fill-mode': 'forwards'
            };
        };
        /**
         * @return {?}
         */
        MoonLoaderComponent.prototype.createMoonBallStyle = /**
         * @return {?}
         */
        function () {
            return __assign({}, this.createBallStyle(this.size / 7), { 'background-color': "" + this.color, 'opacity': '0.8', 'position': 'absolute', 'top': "" + ("" + ((this.size / 2) - (this.size / 14)) + this.sizeUnit), 'animation': 'loading 0.6s 0s infinite linear', 'animation-fill-mode': 'forwards' });
        };
        /**
         * @return {?}
         */
        MoonLoaderComponent.prototype.createMoonCircleStyle = /**
         * @return {?}
         */
        function () {
            return __assign({}, this.createBallStyle(this.size), { 'border': this.size / 7 + "px solid " + this.color, 'opacity': '0.1' });
        };
        /**
         * @private
         * @param {?} size
         * @return {?}
         */
        MoonLoaderComponent.prototype.createBallStyle = /**
         * @private
         * @param {?} size
         * @return {?}
         */
        function (size) {
            return {
                'width': "" + ("" + size + this.sizeUnit),
                'height': "" + ("" + size + this.sizeUnit),
                'border-radius': '100%'
            };
        };
        MoonLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-moon-loader',
                        template: "<div class=\"loader\" [ngStyle]=\"createMoonWrapperStyle()\">\n  <div [ngStyle]=\"createMoonBallStyle()\"></div>\n  <div [ngStyle]=\"createMoonCircleStyle()\"></div>\n</div>\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: ["@-webkit-keyframes loading{100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes loading{100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}"]
                    }] }
        ];
        /** @nocollapse */
        MoonLoaderComponent.ctorParameters = function () { return []; };
        MoonLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            sizeUnit: [{ type: core.Input }]
        };
        return MoonLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var calculateRgba = (/**
     * @param {?} color
     * @param {?} opacity
     * @return {?}
     */
    function (color, opacity) {
        if (color[0] === '#') {
            color = color.slice(1);
        }
        if (color.length === 3) {
            /** @type {?} */
            var res_1 = '';
            color.split('').forEach((/**
             * @param {?} c
             * @return {?}
             */
            function (c) {
                res_1 += c;
                res_1 += c;
            }));
            color = res_1;
        }
        /** @type {?} */
        var rgbValues = color.match(/.{2}/g).map((/**
         * @param {?} hex
         * @return {?}
         */
        function (hex) { return parseInt(hex, 16); })).join(', ');
        return "rgba(" + rgbValues + ", " + opacity + ")";
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var HashLoaderComponent = /** @class */ (function () {
        function HashLoaderComponent(elementRef) {
            this.elementRef = elementRef;
            this.color = '#36d7b7';
            this.size = 50;
            this.sizeUnit = 'px';
            this.rgba = (/**
             * @param {?} color
             * @return {?}
             */
            function (color) { return calculateRgba(color, 0.75); });
            this.thickness = (/**
             * @param {?} size
             * @return {?}
             */
            function (size) { return size / 5; });
        }
        /**
         * @return {?}
         */
        HashLoaderComponent.prototype.createHashWrapperStyle = /**
         * @return {?}
         */
        function () {
            return {
                'position': 'relative',
                'width': "" + ("" + this.size + this.sizeUnit),
                'height': "" + ("" + this.size + this.sizeUnit),
                'transform': 'rotate(165deg)'
            };
        };
        /**
         * @param {?} index
         * @param {?} color
         * @param {?} size
         * @param {?} sizeUnit
         * @return {?}
         */
        HashLoaderComponent.prototype.createHashStyle = /**
         * @param {?} index
         * @param {?} color
         * @param {?} size
         * @param {?} sizeUnit
         * @return {?}
         */
        function (index, color, size, sizeUnit) {
            this.setStyleVariables(color, size, sizeUnit);
            return {
                'display': 'block',
                'position': 'absolute',
                'content': '',
                'top': '50%',
                'left': '50%',
                'width': "" + ("" + this.size / 5 + this.sizeUnit),
                'height': "" + ("" + this.size / 5 + this.sizeUnit),
                'border-radius': "" + ("" + this.size / 10 + this.sizeUnit),
                'transform': 'translate(-50%, -50%)',
                'animation-fill-mode': 'none',
                'animation': (index === 1 ? 'loading-before' : 'loading-after') + " 2s infinite"
            };
        };
        /**
         * @private
         * @param {?} size
         * @return {?}
         */
        HashLoaderComponent.prototype.lat = /**
         * @private
         * @param {?} size
         * @return {?}
         */
        function (size) {
            return (this.size - this.thickness(size)) / 2;
        };
        /**
         * @private
         * @param {?} size
         * @return {?}
         */
        HashLoaderComponent.prototype.offset = /**
         * @private
         * @param {?} size
         * @return {?}
         */
        function (size) {
            return this.lat(size) - this.thickness(size);
        };
        /**
         * @private
         * @param {?} color
         * @param {?} size
         * @param {?} sizeUnit
         * @return {?}
         */
        HashLoaderComponent.prototype.setStyleVariables = /**
         * @private
         * @param {?} color
         * @param {?} size
         * @param {?} sizeUnit
         * @return {?}
         */
        function (color, size, sizeUnit) {
            /** @type {?} */
            var rgba = this.rgba(color);
            /** @type {?} */
            var lat = this.lat(size);
            /** @type {?} */
            var thickness = this.thickness(size);
            /** @type {?} */
            var offset = this.offset(size);
            this.elementRef.nativeElement.style.setProperty('--color', rgba);
            this.elementRef.nativeElement.style.setProperty('--size', "" + ("" + size + sizeUnit));
            this.elementRef.nativeElement.style.setProperty('--lat', "" + (lat + "px"));
            this.elementRef.nativeElement.style.setProperty('--thickness', "" + (thickness + "px"));
            this.elementRef.nativeElement.style.setProperty('--offset', "" + (offset + "px"));
        };
        HashLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-hash-loader',
                        template: "<div class=\"loader\" [ngStyle]=\"createHashWrapperStyle()\">\n      <div [ngStyle]=\"createHashStyle(1,color, size, sizeUnit)\"></div>\n      <div [ngStyle]=\"createHashStyle(2, color, size, sizeUnit)\"></div>\n</div>\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: [":host{--color:rgba(54, 215, 183, 0.75);--thickness:10px;--size:50px;--lat:20px;--offset:10px}@-webkit-keyframes loading-before{0%{width:var(--thickness);box-shadow:var(--lat) calc(-1 * var(--offset)) var(--color),calc(-1 * var(--lat)) var(--offset) var(--color)}35%{width:var(--size);box-shadow:0 calc(-1 * var(--offset)) var(--color),0 var(--offset) var(--color)}70%{width:var(--thickness);box-shadow:calc(-1 * var(--lat)) calc(-1 * var(--offset)) var(--color),var(--lat) var(--offset) var(--color)}100%{box-shadow:var(--lat) calc(-1 * var(--offset)) var(--color),calc(-1 * var(--lat)) var(--offset) var(--color)}}@keyframes loading-before{0%{width:var(--thickness);box-shadow:var(--lat) calc(-1 * var(--offset)) var(--color),calc(-1 * var(--lat)) var(--offset) var(--color)}35%{width:var(--size);box-shadow:0 calc(-1 * var(--offset)) var(--color),0 var(--offset) var(--color)}70%{width:var(--thickness);box-shadow:calc(-1 * var(--lat)) calc(-1 * var(--offset)) var(--color),var(--lat) var(--offset) var(--color)}100%{box-shadow:var(--lat) calc(-1 * var(--offset)) var(--color),calc(-1 * var(--lat)) var(--offset) var(--color)}}@-webkit-keyframes loading-after{0%{height:var(--thickness);box-shadow:var(--offset) var(--lat) var(--color),calc(-1 * var(--offset)) calc(-1 * var(--lat)) var(--color)}35%{height:var(--size);box-shadow:var(--offset) 0 var(--color),calc(-1 * var(--offset)) 0 var(--color)}70%{height:var(--thickness);box-shadow:var(--offset) calc(-1 * var(--lat)) var(--color),calc(-1 * var(--offset)) var(--lat) var(--color)}100%{box-shadow:var(--offset) var(--lat) var(--color),calc(-1 * var(--offset)) calc(-1 * var(--lat)) var(--color)}}@keyframes loading-after{0%{height:var(--thickness);box-shadow:var(--offset) var(--lat) var(--color),calc(-1 * var(--offset)) calc(-1 * var(--lat)) var(--color)}35%{height:var(--size);box-shadow:var(--offset) 0 var(--color),calc(-1 * var(--offset)) 0 var(--color)}70%{height:var(--thickness);box-shadow:var(--offset) calc(-1 * var(--lat)) var(--color),calc(-1 * var(--offset)) var(--lat) var(--color)}100%{box-shadow:var(--offset) var(--lat) var(--color),calc(-1 * var(--offset)) calc(-1 * var(--lat)) var(--color)}}"]
                    }] }
        ];
        /** @nocollapse */
        HashLoaderComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        HashLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            sizeUnit: [{ type: core.Input }]
        };
        return HashLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var GridLoaderComponent = /** @class */ (function () {
        function GridLoaderComponent() {
            this.color = 'rgb(54, 215, 183)';
            this.size = 15;
            this.sizeUnit = 'px';
            this.margin = 2;
            this.marginUnit = 'px';
        }
        /**
         * @return {?}
         */
        GridLoaderComponent.prototype.createGridWrapperStyle = /**
         * @return {?}
         */
        function () {
            return {
                'width': "" + ("" + ((this.size * 3) + (this.margin * 6)) + this.sizeUnit),
                'font-size': '0'
            };
        };
        /**
         * @param {?} rand
         * @return {?}
         */
        GridLoaderComponent.prototype.createGridStyle = /**
         * @param {?} rand
         * @return {?}
         */
        function (rand) {
            return {
                'display': 'inline-block',
                'background-color': "" + this.color,
                'width': "" + ("" + this.size + this.sizeUnit),
                'height': "" + ("" + this.size + this.sizeUnit),
                'margin': "" + ("" + this.margin + this.marginUnit),
                'border-radius': '100%',
                'animation-fill-mode': 'both',
                'animation': "loading " + ((rand / 100) + 0.6) + "s " + ((rand / 100) - 0.2) + "s infinite ease"
            };
        };
        /**
         * @param {?} top
         * @return {?}
         */
        GridLoaderComponent.prototype.random = /**
         * @param {?} top
         * @return {?}
         */
        function (top) {
            return Math.random() * top;
        };
        GridLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-grid-loader',
                        template: "<div class=\"loader\" [ngStyle]=\"createGridWrapperStyle()\">\n  <div [ngStyle]=\"createGridStyle(random(100))\"></div>\n  <div [ngStyle]=\"createGridStyle(random(100))\"></div>\n  <div [ngStyle]=\"createGridStyle(random(100))\"></div>\n  <div [ngStyle]=\"createGridStyle(random(100))\"></div>\n  <div [ngStyle]=\"createGridStyle(random(100))\"></div>\n  <div [ngStyle]=\"createGridStyle(random(100))\"></div>\n  <div [ngStyle]=\"createGridStyle(random(100))\"></div>\n  <div [ngStyle]=\"createGridStyle(random(100))\"></div>\n  <div [ngStyle]=\"createGridStyle(random(100))\"></div>\n</div>\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: ["@-webkit-keyframes loading{0%{-webkit-transform:scale(1);transform:scale(1)}50%{-webkit-transform:scale(.5);transform:scale(.5);opacity:.7}100%{-webkit-transform:scale(1);transform:scale(1);opacity:1}}@keyframes loading{0%{-webkit-transform:scale(1);transform:scale(1)}50%{-webkit-transform:scale(.5);transform:scale(.5);opacity:.7}100%{-webkit-transform:scale(1);transform:scale(1);opacity:1}}"]
                    }] }
        ];
        /** @nocollapse */
        GridLoaderComponent.ctorParameters = function () { return []; };
        GridLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            sizeUnit: [{ type: core.Input }],
            margin: [{ type: core.Input }],
            marginUnit: [{ type: core.Input }]
        };
        return GridLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FadeLoaderComponent = /** @class */ (function () {
        function FadeLoaderComponent() {
            this.color = 'rgb(54, 215, 183)';
            this.height = 15;
            this.heightUnit = 'px';
            this.width = 5;
            this.widthUnit = 'px';
            this.margin = 2;
            this.marginUnit = 'px';
            this.radius = 2;
            this.radiusUnit = 'px';
            this.radiusFactor = 20;
        }
        /**
         * @return {?}
         */
        FadeLoaderComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        /**
         * @return {?}
         */
        FadeLoaderComponent.prototype.createFadeWrapperStyle = /**
         * @return {?}
         */
        function () {
            return {
                'position': 'relative',
                'font-size': '0',
                'top': this.radiusFactor + "px",
                'left': this.radiusFactor + "px",
                'width': this.radiusFactor * 3 + "px",
                'height': this.radiusFactor * 3 + "px"
            };
        };
        /**
         * @return {?}
         */
        FadeLoaderComponent.prototype.createFadeStyleA = /**
         * @return {?}
         */
        function () {
            return __assign({}, this.createFadeStyle(1), { 'top': this.radiusFactor + "px", 'left': '0' });
        };
        /**
         * @return {?}
         */
        FadeLoaderComponent.prototype.createFadeStyleB = /**
         * @return {?}
         */
        function () {
            return __assign({}, this.createFadeStyle(2), { 'top': this.createQuarter() + "px", 'left': this.createQuarter() + "px", 'transform': 'rotate(-45deg)' });
        };
        /**
         * @return {?}
         */
        FadeLoaderComponent.prototype.createFadeStyleC = /**
         * @return {?}
         */
        function () {
            return __assign({}, this.createFadeStyle(3), { 'top': '0', 'left': this.radiusFactor + "px", 'transform': 'rotate(90deg)' });
        };
        /**
         * @return {?}
         */
        FadeLoaderComponent.prototype.createFadeStyleD = /**
         * @return {?}
         */
        function () {
            return __assign({}, this.createFadeStyle(4), { 'top': -1 * this.createQuarter() + "px", 'left': this.createQuarter() + "px", 'transform': 'rotate(45deg)' });
        };
        /**
         * @return {?}
         */
        FadeLoaderComponent.prototype.createFadeStyleE = /**
         * @return {?}
         */
        function () {
            return __assign({}, this.createFadeStyle(5), { 'top': -1 * this.radiusFactor + "px", 'left': '0' });
        };
        /**
         * @return {?}
         */
        FadeLoaderComponent.prototype.createFadeStyleF = /**
         * @return {?}
         */
        function () {
            return __assign({}, this.createFadeStyle(6), { 'top': -1 * this.createQuarter() + "px", 'left': -1 * this.createQuarter() + "px", 'transform': 'rotate(-45deg)' });
        };
        /**
         * @return {?}
         */
        FadeLoaderComponent.prototype.createFadeStyleG = /**
         * @return {?}
         */
        function () {
            return __assign({}, this.createFadeStyle(7), { 'top': '0', 'left': -1 * this.radiusFactor + "px", 'transform': 'rotate(90deg)' });
        };
        /**
         * @return {?}
         */
        FadeLoaderComponent.prototype.createFadeStyleH = /**
         * @return {?}
         */
        function () {
            return __assign({}, this.createFadeStyle(8), { 'top': this.createQuarter() + "px", 'left': -1 * this.createQuarter() + "px", 'transform': 'rotate(45deg)' });
        };
        /**
         * @private
         * @param {?} index
         * @return {?}
         */
        FadeLoaderComponent.prototype.createFadeStyle = /**
         * @private
         * @param {?} index
         * @return {?}
         */
        function (index) {
            return {
                'position': 'absolute',
                'width': "" + ("" + this.width + this.widthUnit),
                'height': "" + ("" + this.height + this.heightUnit),
                'margin': "" + ("" + this.margin + this.marginUnit),
                'background-color': "" + this.color,
                'border-radius': "" + ("" + this.radius + this.radiusUnit),
                'transition': '2s',
                'animation-fill-mode': 'both',
                'animation': "loading 1.2s " + index * 0.12 + "s infinite ease-in-out"
            };
        };
        /**
         * @private
         * @return {?}
         */
        FadeLoaderComponent.prototype.createQuarter = /**
         * @private
         * @return {?}
         */
        function () {
            return (this.radiusFactor / 2) + (this.radiusFactor / 5.5);
        };
        FadeLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-fade-loader',
                        template: "<div class=\"loading\" [ngStyle]=\"createFadeWrapperStyle()\">\n  <div [ngStyle]=\"createFadeStyleA()\"></div>\n  <div [ngStyle]=\"createFadeStyleB()\"></div>\n  <div [ngStyle]=\"createFadeStyleC()\"></div>\n  <div [ngStyle]=\"createFadeStyleD()\"></div>\n  <div [ngStyle]=\"createFadeStyleE()\"></div>\n  <div [ngStyle]=\"createFadeStyleF()\"></div>\n  <div [ngStyle]=\"createFadeStyleG()\"></div>\n  <div [ngStyle]=\"createFadeStyleH()\"></div>\n</div>\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: ["@-webkit-keyframes loading{50%{opacity:.3}100%{opacity:1}}@keyframes loading{50%{opacity:.3}100%{opacity:1}}"]
                    }] }
        ];
        /** @nocollapse */
        FadeLoaderComponent.ctorParameters = function () { return []; };
        FadeLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            height: [{ type: core.Input }],
            heightUnit: [{ type: core.Input }],
            width: [{ type: core.Input }],
            widthUnit: [{ type: core.Input }],
            margin: [{ type: core.Input }],
            marginUnit: [{ type: core.Input }],
            radius: [{ type: core.Input }],
            radiusUnit: [{ type: core.Input }]
        };
        return FadeLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DotLoaderComponent = /** @class */ (function () {
        function DotLoaderComponent() {
            this.color = 'rgb(54, 215, 183)';
            this.size = 60;
            this.sizeUnit = 'px';
        }
        /**
         * @return {?}
         */
        DotLoaderComponent.prototype.createDotWrapperStyle = /**
         * @return {?}
         */
        function () {
            return {
                'position': 'relative',
                'width': "" + ("" + this.size + this.sizeUnit),
                'height': "" + ("" + this.size + this.sizeUnit),
                'animation-fill-mode': 'forwards',
                'animation': 'loading-rotate 2s 0s infinite linear'
            };
        };
        /**
         * @param {?} index
         * @return {?}
         */
        DotLoaderComponent.prototype.createDotStyle = /**
         * @param {?} index
         * @return {?}
         */
        function (index) {
            return {
                'position': 'absolute',
                'top': "" + (index % 2 ? '0' : 'auto'),
                'bottom': "" + (index % 2 ? 'auto' : '0'),
                'height': "" + ("" + this.size / 2 + this.sizeUnit),
                'width': "" + ("" + this.size / 2 + this.sizeUnit),
                'background-color': "" + this.color,
                'border-radius': '100%',
                'animation-fill-mode': 'forwards',
                'animation': "loading-bounce 2s " + (index === 2 ? '-1s' : '0s') + " infinite linear"
            };
        };
        DotLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-dot-loader',
                        template: "<div class=\"loader\" [ngStyle]=\"createDotWrapperStyle()\">\n  <div [ngStyle]=\"createDotStyle(1)\"></div>\n  <div [ngStyle]=\"createDotStyle(2)\"></div>\n</div>\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: ["@-webkit-keyframes loading-rotate{100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes loading-rotate{100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@-webkit-keyframes loading-bounce{0%,100%{-webkit-transform:scale(0);transform:scale(0)}50%{-webkit-transform:scale(1);transform:scale(1)}}@keyframes loading-bounce{0%,100%{-webkit-transform:scale(0);transform:scale(0)}50%{-webkit-transform:scale(1);transform:scale(1)}}"]
                    }] }
        ];
        /** @nocollapse */
        DotLoaderComponent.ctorParameters = function () { return []; };
        DotLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            sizeUnit: [{ type: core.Input }]
        };
        return DotLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ClipLoaderComponent = /** @class */ (function () {
        function ClipLoaderComponent() {
            this.color = 'rgb(54, 215, 183)';
            this.size = 35;
            this.sizeUnit = 'px';
        }
        /**
         * @return {?}
         */
        ClipLoaderComponent.prototype.createClipStyle = /**
         * @return {?}
         */
        function () {
            return {
                'background': 'transparent !important',
                'width': "" + ("" + this.size + this.sizeUnit),
                'height': "" + ("" + this.size + this.sizeUnit),
                'border-radius': '100%',
                'border': '2px solid',
                'border-color': "" + this.color,
                'border-bottom-color': 'transparent',
                'display': 'inline-block',
                'animation': ' loading 0.75s 0s infinite linear',
                'animation-fill-mode': 'both'
            };
        };
        ClipLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-clip-loader',
                        template: "<div class=\"loader\" [ngStyle]=\"createClipStyle()\"></div>\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: ["@-webkit-keyframes loading{0%{-webkit-transform:rotate(0) scale(1);transform:rotate(0) scale(1)}50%{-webkit-transform:rotate(180deg) scale(.8);transform:rotate(180deg) scale(.8)}100%{-webkit-transform:rotate(360deg) scale(1);transform:rotate(360deg) scale(1)}}@keyframes loading{0%{-webkit-transform:rotate(0) scale(1);transform:rotate(0) scale(1)}50%{-webkit-transform:rotate(180deg) scale(.8);transform:rotate(180deg) scale(.8)}100%{-webkit-transform:rotate(360deg) scale(1);transform:rotate(360deg) scale(1)}}"]
                    }] }
        ];
        /** @nocollapse */
        ClipLoaderComponent.ctorParameters = function () { return []; };
        ClipLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            sizeUnit: [{ type: core.Input }]
        };
        return ClipLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ClimbingBoxLoaderComponent = /** @class */ (function () {
        function ClimbingBoxLoaderComponent() {
            this.color = 'rgb(54, 215, 183)';
            this.size = 15;
            this.sizeUnit = 'px';
        }
        /**
         * @return {?}
         */
        ClimbingBoxLoaderComponent.prototype.createClimbingBoxContainerStyle = /**
         * @return {?}
         */
        function () {
            return {
                'position': 'relative',
                'width': '7.1em',
                'height': '7.1em'
            };
        };
        /**
         * @return {?}
         */
        ClimbingBoxLoaderComponent.prototype.createClimbingBoxWrapperStyle = /**
         * @return {?}
         */
        function () {
            return {
                'position': 'absolute',
                'top': '50%',
                'left': '50%',
                'margin-top': '-2.7em',
                'margin-left': '-2.7em',
                'width': '5.4em',
                'height': '5.4em',
                'font-size': "" + ("" + this.size + this.sizeUnit)
            };
        };
        /**
         * @return {?}
         */
        ClimbingBoxLoaderComponent.prototype.createClimbingBoxStyle = /**
         * @return {?}
         */
        function () {
            return {
                'position': 'absolute',
                'left': '0',
                'bottom': '-0.1em',
                'height': '1em',
                'width': '1em',
                'background-color': 'transparent',
                'border-radius': '15%',
                'border': "0.25em solid " + this.color,
                'transform': 'translate(0, -1em) rotate(-45deg)',
                'animation-fill-mode': 'both',
                'animation': 'loading 2.5s infinite cubic-bezier(.79, 0, .47, .97)'
            };
        };
        /**
         * @return {?}
         */
        ClimbingBoxLoaderComponent.prototype.createHillStyle = /**
         * @return {?}
         */
        function () {
            return {
                'position': 'absolute',
                'width': '7.1em',
                'height': '7.1em',
                'top': '1.7em',
                'left': '1.7em',
                'border-left': "0.25em solid " + this.color,
                'transform': 'rotate(45deg)'
            };
        };
        ClimbingBoxLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-climbing-box-loader',
                        template: "<div class=\"loader\" [ngStyle]=\"createClimbingBoxContainerStyle()\">\n  <div [ngStyle]=\"createClimbingBoxWrapperStyle()\">\n    <div [ngStyle]=\"createClimbingBoxStyle()\"></div>\n    <div [ngStyle]=\"createHillStyle()\"></div>\n  </div>\n</div>\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: ["@-webkit-keyframes loading{0%{-webkit-transform:translate(0,-1em) rotate(-45deg);transform:translate(0,-1em) rotate(-45deg)}5%{-webkit-transform:translate(0,-1em) rotate(-50deg);transform:translate(0,-1em) rotate(-50deg)}20%{-webkit-transform:translate(1em,-2em) rotate(47deg);transform:translate(1em,-2em) rotate(47deg)}25%{-webkit-transform:translate(1em,-2em) rotate(45deg);transform:translate(1em,-2em) rotate(45deg)}30%{-webkit-transform:translate(1em,-2em) rotate(40deg);transform:translate(1em,-2em) rotate(40deg)}45%{-webkit-transform:translate(2em,-3em) rotate(137deg);transform:translate(2em,-3em) rotate(137deg)}50%{-webkit-transform:translate(2em,-3em) rotate(135deg);transform:translate(2em,-3em) rotate(135deg)}55%{-webkit-transform:translate(2em,-3em) rotate(130deg);transform:translate(2em,-3em) rotate(130deg)}70%{-webkit-transform:translate(3em,-4em) rotate(217deg);transform:translate(3em,-4em) rotate(217deg)}75%{-webkit-transform:translate(3em,-4em) rotate(220deg);transform:translate(3em,-4em) rotate(220deg)}100%{-webkit-transform:translate(0,-1em) rotate(-225deg);transform:translate(0,-1em) rotate(-225deg)}}@keyframes loading{0%{-webkit-transform:translate(0,-1em) rotate(-45deg);transform:translate(0,-1em) rotate(-45deg)}5%{-webkit-transform:translate(0,-1em) rotate(-50deg);transform:translate(0,-1em) rotate(-50deg)}20%{-webkit-transform:translate(1em,-2em) rotate(47deg);transform:translate(1em,-2em) rotate(47deg)}25%{-webkit-transform:translate(1em,-2em) rotate(45deg);transform:translate(1em,-2em) rotate(45deg)}30%{-webkit-transform:translate(1em,-2em) rotate(40deg);transform:translate(1em,-2em) rotate(40deg)}45%{-webkit-transform:translate(2em,-3em) rotate(137deg);transform:translate(2em,-3em) rotate(137deg)}50%{-webkit-transform:translate(2em,-3em) rotate(135deg);transform:translate(2em,-3em) rotate(135deg)}55%{-webkit-transform:translate(2em,-3em) rotate(130deg);transform:translate(2em,-3em) rotate(130deg)}70%{-webkit-transform:translate(3em,-4em) rotate(217deg);transform:translate(3em,-4em) rotate(217deg)}75%{-webkit-transform:translate(3em,-4em) rotate(220deg);transform:translate(3em,-4em) rotate(220deg)}100%{-webkit-transform:translate(0,-1em) rotate(-225deg);transform:translate(0,-1em) rotate(-225deg)}}"]
                    }] }
        ];
        /** @nocollapse */
        ClimbingBoxLoaderComponent.ctorParameters = function () { return []; };
        ClimbingBoxLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            sizeUnit: [{ type: core.Input }]
        };
        return ClimbingBoxLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CircleLoaderComponent = /** @class */ (function () {
        function CircleLoaderComponent() {
            this.color = 'rgb(54, 215, 183)';
            this.size = 50;
            this.sizeUnit = 'px';
        }
        /**
         * @return {?}
         */
        CircleLoaderComponent.prototype.createCircleWrapperStyle = /**
         * @return {?}
         */
        function () {
            return {
                'position': 'relative',
                'width': "" + ("" + this.size + this.sizeUnit),
                'height': "" + ("" + this.size + this.sizeUnit)
            };
        };
        /**
         * @param {?} index
         * @return {?}
         */
        CircleLoaderComponent.prototype.createCircleStyle = /**
         * @param {?} index
         * @return {?}
         */
        function (index) {
            return {
                'position': 'absolute',
                'height': "" + ("" + this.size * (1 - (index / 10)) + this.sizeUnit),
                'width': "" + ("" + this.size * (1 - (index / 10)) + this.sizeUnit),
                'border': "1px solid " + this.color,
                'border-radius': '100%',
                'transition': '2s',
                'border-bottom': 'none',
                'border-right': 'none',
                'top': (index * 0.7 * 2.5) + "%",
                'left': (index * 0.35 * 2.5) + "%",
                'animation-fill-mode': '',
                'animation': "loading 1s " + index * 0.2 + "s infinite linear"
            };
        };
        CircleLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-circle-loader',
                        template: "<div class=\"loader\" [ngStyle]=\"createCircleWrapperStyle()\">\n  <div [ngStyle]=\"createCircleStyle(0)\"></div>\n  <div [ngStyle]=\"createCircleStyle(1)\"></div>\n  <div [ngStyle]=\"createCircleStyle(2)\"></div>\n  <div [ngStyle]=\"createCircleStyle(3)\"></div>\n  <div [ngStyle]=\"createCircleStyle(4)\"></div>\n</div>\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: ["@-webkit-keyframes loading{0%{-webkit-transform:rotate(0);transform:rotate(0)}50%{-webkit-transform:rotate(180deg);transform:rotate(180deg)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes loading{0%{-webkit-transform:rotate(0);transform:rotate(0)}50%{-webkit-transform:rotate(180deg);transform:rotate(180deg)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}"]
                    }] }
        ];
        /** @nocollapse */
        CircleLoaderComponent.ctorParameters = function () { return []; };
        CircleLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            sizeUnit: [{ type: core.Input }]
        };
        return CircleLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BounceLoaderComponent = /** @class */ (function () {
        function BounceLoaderComponent() {
            this.color = 'rgb(54, 215, 183)';
            this.size = 60;
            this.sizeUnit = 'px';
        }
        /**
         * @return {?}
         */
        BounceLoaderComponent.prototype.createBounceWrapperStyle = /**
         * @return {?}
         */
        function () {
            return {
                'position': 'relative',
                'width': "" + ("" + this.size + this.sizeUnit),
                'height': "" + ("" + this.size + this.sizeUnit)
            };
        };
        /**
         * @param {?} index
         * @return {?}
         */
        BounceLoaderComponent.prototype.createBounceStyle = /**
         * @param {?} index
         * @return {?}
         */
        function (index) {
            return {
                'position': 'absolute',
                'height': "" + ("" + this.size + this.sizeUnit),
                'width': "" + ("" + this.size + this.sizeUnit),
                'background-color': "" + this.color,
                'border-radius': '100%',
                'opacity': '0.6',
                'top': '0',
                'left': '0',
                'animation-fill-mode': 'both',
                'animation': "loading 2.1s " + (index === 1 ? '1s' : '0s') + " infinite ease-in-out"
            };
        };
        BounceLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-bounce-loader',
                        template: "<div class=\"loader\" [ngStyle]=\"createBounceWrapperStyle()\">\n  <div [ngStyle]=\"createBounceStyle(1)\"></div>\n  <div [ngStyle]=\"createBounceStyle(2)\"></div>\n</div>\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: ["@-webkit-keyframes loading{0%,100%{-webkit-transform:scale(0);transform:scale(0)}50%{-webkit-transform:scale(1);transform:scale(1)}}@keyframes loading{0%,100%{-webkit-transform:scale(0);transform:scale(0)}50%{-webkit-transform:scale(1);transform:scale(1)}}"]
                    }] }
        ];
        /** @nocollapse */
        BounceLoaderComponent.ctorParameters = function () { return []; };
        BounceLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            sizeUnit: [{ type: core.Input }]
        };
        return BounceLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BeatLoaderComponent = /** @class */ (function () {
        function BeatLoaderComponent() {
            this.color = 'rgb(54, 215, 183)';
            this.size = 15;
            this.sizeUnit = 'px';
            this.margin = 2;
            this.marginUnit = 'px';
        }
        /**
         * @param {?} index
         * @return {?}
         */
        BeatLoaderComponent.prototype.createBeatStyle = /**
         * @param {?} index
         * @return {?}
         */
        function (index) {
            return {
                'display': 'inline-block',
                'background-color': "" + this.color,
                'width': "" + ("" + this.size + this.sizeUnit),
                'height': "" + ("" + this.size + this.sizeUnit),
                'margin': "" + ("" + this.margin + this.marginUnit),
                'border-radius': '100%',
                'animation': "loading 0.7s " + (index % 2 ? '0s' : '0.35s') + " infinite linear",
                'animation-fill-mode': 'both'
            };
        };
        BeatLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-beat-loader',
                        template: "<div class=\"loader\">\n  <div [ngStyle]=\"createBeatStyle(1)\"></div>\n  <div [ngStyle]=\"createBeatStyle(2)\"></div>\n  <div [ngStyle]=\"createBeatStyle(3)\"></div>\n</div>\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: ["@-webkit-keyframes loading{50%{-webkit-transform:scale(.75);transform:scale(.75);opacity:.2}100%{-webkit-transform:scale(1);transform:scale(1);opacity:1}}@keyframes loading{50%{-webkit-transform:scale(.75);transform:scale(.75);opacity:.2}100%{-webkit-transform:scale(1);transform:scale(1);opacity:1}}"]
                    }] }
        ];
        /** @nocollapse */
        BeatLoaderComponent.ctorParameters = function () { return []; };
        BeatLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            sizeUnit: [{ type: core.Input }],
            margin: [{ type: core.Input }],
            marginUnit: [{ type: core.Input }]
        };
        return BeatLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BarLoaderComponent = /** @class */ (function () {
        function BarLoaderComponent() {
            this.color = '#36d7b7';
            this.width = 100;
            this.widthUnit = 'px';
            this.height = 4;
            this.heightUnit = 'px';
        }
        /**
         * @return {?}
         */
        BarLoaderComponent.prototype.createBarWrapperStyle = /**
         * @return {?}
         */
        function () {
            return {
                'position': 'relative',
                'width': "" + ("" + this.width + this.widthUnit),
                'height': "" + ("" + this.height + this.heightUnit),
                'overflow': 'hidden',
                'background-color': "" + calculateRgba(this.color, 0.2),
                'background-clip': 'padding-box',
            };
        };
        /**
         * @param {?} index
         * @return {?}
         */
        BarLoaderComponent.prototype.createBarStyle = /**
         * @param {?} index
         * @return {?}
         */
        function (index) {
            return {
                'display': 'block',
                'position': 'absolute',
                'height': "" + ("" + this.height + this.heightUnit),
                'overflow': 'hidden',
                'background-color': "" + this.color,
                'background-clip': 'padding-box',
                'border-radius': '2px',
                'will-change': 'left, right',
                'animation-fill-mode': 'forwards',
                'animation': (index === 1 ? 'loading-long' : 'loading-short') + " 2.1s " + (index === 2 ? '1.15s' : '') + "\n                    " + (index === 1 ? 'cubic-bezier(0.65, 0.815, 0.735, 0.395)' : 'cubic-bezier(0.165, 0.84, 0.44, 1)') + " infinite"
            };
        };
        BarLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-bar-loader',
                        template: "<div class=\"loading\" [ngStyle]=\"createBarWrapperStyle()\">\r\n  <div [ngStyle]=\"createBarStyle(1)\"></div>\r\n  <div [ngStyle]=\"createBarStyle(2)\"></div>\r\n</div>\r\n",
                        encapsulation: core.ViewEncapsulation.ShadowDom,
                        styles: ["@-webkit-keyframes loading-long{0%{left:-35%;right:100%}100%,60%{left:100%;right:-90%}}@keyframes loading-long{0%{left:-35%;right:100%}100%,60%{left:100%;right:-90%}}@-webkit-keyframes loading-short{0%{left:-200%;right:100%}100%,60%{left:107%;right:-8%}}@keyframes loading-short{0%{left:-200%;right:100%}100%,60%{left:107%;right:-8%}}"]
                    }] }
        ];
        /** @nocollapse */
        BarLoaderComponent.ctorParameters = function () { return []; };
        BarLoaderComponent.propDecorators = {
            color: [{ type: core.Input }],
            width: [{ type: core.Input }],
            widthUnit: [{ type: core.Input }],
            height: [{ type: core.Input }],
            heightUnit: [{ type: core.Input }]
        };
        return BarLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var components = [
        SyncLoaderComponent,
        SquareLoaderComponent,
        SkewLoaderComponent,
        ScaleLoaderComponent,
        RotateLoaderComponent,
        RiseLoaderComponent,
        RingLoaderComponent,
        PulseLoaderComponent,
        PropagateLoaderComponent,
        PacmanLoaderComponent,
        MoonLoaderComponent,
        HashLoaderComponent,
        GridLoaderComponent,
        FadeLoaderComponent,
        DotLoaderComponent,
        ClipLoaderComponent,
        ClimbingBoxLoaderComponent,
        CircleLoaderComponent,
        BounceLoaderComponent,
        BeatLoaderComponent,
        BarLoaderComponent
    ];
    var NgxSpinnersModule = /** @class */ (function () {
        function NgxSpinnersModule() {
        }
        NgxSpinnersModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: components,
                        imports: [common.CommonModule],
                        exports: components
                    },] }
        ];
        return NgxSpinnersModule;
    }());

    exports.NgxSpinnersModule = NgxSpinnersModule;
    exports.ɵa = SyncLoaderComponent;
    exports.ɵb = SquareLoaderComponent;
    exports.ɵc = SkewLoaderComponent;
    exports.ɵd = ScaleLoaderComponent;
    exports.ɵe = RotateLoaderComponent;
    exports.ɵf = RiseLoaderComponent;
    exports.ɵg = RingLoaderComponent;
    exports.ɵh = PulseLoaderComponent;
    exports.ɵi = PropagateLoaderComponent;
    exports.ɵj = PacmanLoaderComponent;
    exports.ɵk = MoonLoaderComponent;
    exports.ɵl = HashLoaderComponent;
    exports.ɵm = GridLoaderComponent;
    exports.ɵn = FadeLoaderComponent;
    exports.ɵo = DotLoaderComponent;
    exports.ɵp = ClipLoaderComponent;
    exports.ɵq = ClimbingBoxLoaderComponent;
    exports.ɵr = CircleLoaderComponent;
    exports.ɵs = BounceLoaderComponent;
    exports.ɵt = BeatLoaderComponent;
    exports.ɵu = BarLoaderComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-spinners.umd.js.map
